<?php

class FileDate extends Plugin {


    /***************************************************************
    * 
    * Gibt den HTML-Code zurück, mit dem die Plugin-Variable ersetzt 
    * wird. Der String-Parameter $value ist Pflicht, kann aber leer 
    * sein.
    * 
    ***************************************************************/
    function getContent($value) {
		global $specialchars;
		global $CONTENT_DIR_REL;
		global $CONTENT_FILES_DIR_NAME;
		global $CAT_REQUEST;
		
		// Kein Datumsformat konfiguriert?
		if (!$this->settings->get("dateformat")) {
			return $this->buildErrorMsg("Kein Datumsformat konfiguriert!");
		}

		$cat = $CAT_REQUEST;
		$valuearray = explode(":", $value);	
		// Datei in aktueller Kategorie
        if (count($valuearray) == 1) {
			$datei = $specialchars->replaceSpecialChars($specialchars->getHtmlEntityDecode($value),false);
            if (file_exists($CONTENT_DIR_REL.$cat."/".$CONTENT_FILES_DIR_NAME."/".$datei)) {
				return @strftime($this->settings->get("dateformat"), filemtime($CONTENT_DIR_REL.$cat."/".$CONTENT_FILES_DIR_NAME."/".$datei));
			}
			else {
				return $this->buildErrorMsg("Datei ".$datei." nicht vorhanden!");
			}
		}
        // Datei in anderer Kategorie
        else {
			$datei_cat = nameToCategory($specialchars->replaceSpecialChars($specialchars->getHtmlEntityDecode($valuearray[0]),false));
            $datei = $specialchars->replaceSpecialChars($specialchars->getHtmlEntityDecode($valuearray[1]),false);
			$html_datei_cat = $specialchars->rebuildSpecialChars($datei_cat,true,true);
            $html_datei = $specialchars->rebuildSpecialChars($datei,true,true);

            if ((!$datei_cat == "") && (file_exists($CONTENT_DIR_REL.$datei_cat))) {
				if (file_exists($CONTENT_DIR_REL.$datei_cat."/".$CONTENT_FILES_DIR_NAME."/".$datei)) {
					return @strftime($this->settings->get("dateformat"), filemtime($CONTENT_DIR_REL.$datei_cat."/".$CONTENT_FILES_DIR_NAME."/".$datei));
				}
                else {
					return $this->buildErrorMsg("Datei ".$html_datei." in Kategorie ".$html_datei_cat." nicht vorhanden!");
                }
            }
            else {
				return $this->buildErrorMsg("Kategorie ".$html_datei_cat." nicht vorhanden!");
            }
        }
    } // function getContent
				
				
	
	// Zusatzfunktion: Gibt Fehlermeldung aus
	function buildErrorMsg($msg) {
		return '<span class="deadlink">Fehler im Plugin FileDate: '.$msg.'</span>';
	}
    
    
    
    /***************************************************************
    * 
    * Gibt die Konfigurationsoptionen als Array zurück.
    * Ist keine Konfiguration nötig, ist dieses Array leer.
    * 
    ***************************************************************/
    function getConfig() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");

        // Rückgabe-Array initialisieren
        // Das muß auf jeden Fall geschehen!
        $config = array();
        
        $config['dateformat']  = array(
            "type" => "text",
            "description" => "PHP-Datumsformat"
        );
        
		return $config;
    } // function getConfig    
    
    
    /***************************************************************
    * 
    * Gibt die Plugin-Infos als Array zurück - in dieser 
    * Reihenfolge:
    *   - Name und Version des Plugins
    *   - für moziloCMS-Version
    *   - Kurzbeschreibung
    *   - Name des Autors
    *   - Download-URL
    *   - Platzhalter für die Selectbox
    * 
    ***************************************************************/
    function getInfo() {
        global $ADMIN_CONF;
        $language = $ADMIN_CONF->get("language");
        # nur eine Sprache ---------------------------------
        $info = array(
            // Plugin-Name + Version
            "<b>FileDate</b> 1.0.2010-09-21",
            // moziloCMS-Version
            "1.12",
            // Kurzbeschreibung nur <span> und <br /> sind erlaubt
            "Gibt das Datum der letzten Änderung einer Datei aus. <br />"
			."<br />"
			."Die Datei muss genau wie im [datei|...]-Element notiert werden.<br />"
			."Beispiel für Datei in aktueller Kategorie: {FileDate|mozilo.jpg}<br />"
			."Beispiel für Datei in anderer Kategorie: {FileDate|Andere Kategorie:mozilo.jpg}<br />"
			."<br />"
			."Das Ausgabeformat des Datums kann - nach den Regeln der PHP-Funktion <span style=\"font-family:monospace\">date()</span> - konfiguriert werden.<br />"
			."Details dazu: http://php.net/manual/de/function.date.php<br />"
			."Beispiel: %d.%m.%Y, %H:%M:%S",
			// Name des Autors
            "Arvid Zimmermann",
            // Download-URL
            "http://software.azett.com",
            // Platzhalter für die Selectbox in der Editieransicht 
            // - ist das Array leer, erscheint das Plugin nicht in der Selectbox
            array(
                '{FileDate|}' => 'Änderungsdatum einer Datei'
            )
        );
        // Rückgabe der Infos.
        // Auch hier könnte man die Inhalte natürlich von der aktuell im Admin eingestellten 
        // Sprache abhängig machen - siehe getConfig().
        return $info;
        
    } // function getInfo

} // class FileDate

?>